export interface WebCellComponent<P = {}> extends Element {
    connectedCallback?(): void;
    attributeChangedCallback?(name: keyof P, oldValue: string, newValue: string): void;
    adoptedCallback?(): void;
    disconnectedCallback?(): void;
    visibleRoot?: Element;
    props: Props<P>;
    emit(event: string, detail: any, options: EventInit): boolean;
}
declare type Props<T> = {
    [P in keyof T]: T[P];
};
export declare function mixin<P>(superClass?: {
    new (): HTMLElement;
    prototype: HTMLElement;
}): {
    new (): WebCellComponent<P>;
};
export {};
